v_price={5000,5000} --turret,rocket_turret price, how much does the rocket turret cost?
v_rocket_interval=25 --50 = 1 second, 25 = 1/2 second, how fast does the rocket turret shoot? every x frames?
v_rocket_build_time=250 --50 = 1 second, 250 = 5 seconds, how long does it take to build a rocket turret?
v_rocket_speed=8 --32 = 1 tile, 8 = 1/4 tile, how much distance does the rocket travel each frame?
v_rocket_limit=3 --max rocket turrets per player
v_rocket_splash=128 --splash range
v_rocket_damage=50 --splash damage

addhook("build","_build")
addhook("menu","_menu")
addhook("always","_always")
addhook("objectkill","_objectkill")

t_tmp_turret={}
t_pre_rocket_turret={}
t_rocket_turret={}
t_rocket={}

for v_temp=1,32 do
	t_tmp_turret[v_temp]={}
	t_pre_rocket_turret[v_temp]={}
	t_rocket_turret[v_temp]={}
end

function _build(id,type,x,y)
	if type==8 then
		t_tmp_turret[id]={x,y}
		menu(id, "Construct - Turret,Standard|"..v_price[1].." $,Rocket|"..v_price[2].." $")
		return 1
	end
end

function _menu(id,title,button)
	if button==0 then
		return 1
	end
	if title=="Construct - Turret" then
		v_limit=0
		for value4,key4 in pairs(t_rocket_turret) do
			t_temp2={}
			for value5,key5 in pairs(t_rocket_turret[value4]) do
				for value6,key6 in pairs(t_rocket_turret[value4][value5]) do
				t_temp2[value6]=key6
					if value6==3 then
						if object(t_temp2[1], "player")==id then
							v_limit=v_limit+1
						end
					end
				end
			end
		end
			if v_limit>=v_rocket_limit then
				msg2(id, "255000000You can't build more buildings of this type@C")
				return 1
			end
		if math.abs(t_tmp_turret[id][1]-player(id, "tilex")) > 1 or math.abs(t_tmp_turret[id][2]-player(id, "tiley")) > 1 or (math.abs(t_tmp_turret[id][1]-player(id, "tilex")) == 0 and math.abs(t_tmp_turret[id][2]-player(id, "tiley")) == 0) then
			msg2(id, "255000000You can't build here@C")
			return 1
		else
			if player(id, "money")<v_price[button] then
				msg2(id, "255000000You have insufficient funds")
				return 1
			end
			parse("spawnobject 10 "..t_tmp_turret[id][1].." "..t_tmp_turret[id][2].." 0 0 "..player(id, "team").." "..id)
			parse("setmoney "..id.." "..math.floor(player(id, "money")-v_price[button]))
			table.insert(t_pre_rocket_turret[id], {button, t_tmp_turret[id][1], t_tmp_turret[id][2], v_rocket_build_time})
			return 1
		end
	end
end

function _always()
	for v_temp=1,32 do
		if #t_pre_rocket_turret[v_temp]>0 then
			for value,key in pairs(t_pre_rocket_turret[v_temp]) do
				t_temp={}
				for value2,key2 in pairs(t_pre_rocket_turret[v_temp][value]) do
					t_temp[value2]=key2
					if value2==4 then
						key2=key2-1
						if key2==0 then
								for value3,key3 in pairs(object(0, "table")) do
									if object(key3, "tilex")==t_temp[2] and object(key3, "tiley")==t_temp[3] then
										parse("killobject "..key3)
									end
								end
							if t_temp[1]==1 then
								parse("spawnobject 8 "..t_temp[2].." "..t_temp[3].." 0 0 "..player(v_temp, "team").." "..v_temp)
							else
								parse("spawnobject 3 "..t_temp[2].." "..t_temp[3].." 0 0 "..player(v_temp, "team").." "..v_temp)
								for value3,key3 in pairs(object(0, "table")) do
									if object(key3, "tilex")==t_temp[2] and object(key3, "tiley")==t_temp[3] then
										table.insert(t_rocket_turret[v_temp], {key3, image("gfx/rocket_turret.PNG",math.floor(object(key3, "x")+16),math.floor(object(key3, "y")+16), 3), 1})
									end
								end
							end
							t_pre_rocket_turret[v_temp][value]=nil
						end
						t_pre_rocket_turret[v_temp][value]={t_temp[1], t_temp[2], t_temp[3], key2}
					end
				end
			end
		end
		if #t_rocket_turret[v_temp]>0 then
			t_temp={}
			for value,key in pairs(t_rocket_turret[v_temp]) do
				for value2,key2 in pairs(t_rocket_turret[v_temp][value]) do	
					t_temp[value2]=key2
					if value2==3 then
						key2=key2-1
						if key2==0 then
							if collision(t_temp[1], find_target(t_temp[1]))==true then
								key2=1
							else
								if find_target(t_temp[1])==0 then
									key2=1
								else
									fire_rocket(t_temp[1],find_target(t_temp[1]))
									key2=v_rocket_interval
								end
							end
						end
					end
					t_rocket_turret[v_temp][value]={t_temp[1], t_temp[2], key2}
				end
			end
		end
	end
	if #t_rocket>0 then
		t_temp={}
		for value6,key6 in pairs(t_rocket) do
			for value7,key7 in pairs(t_rocket[value6]) do
				t_temp[value7]=key7
				if value7==5 then
					if tile(math.floor(t_temp[2]/32), math.floor(t_temp[3]/32), "wall")==true and check_notself(t_temp[5],t_temp[2],t_temp[3])==true or hit_player(t_temp[5],t_temp[2],t_temp[3])==true then
						freeimage(t_temp[1])
						parse("explosion ".." "..t_temp[2].." "..t_temp[3].." "..v_rocket_splash.." "..v_rocket_damage.." "..object(t_temp[5], "player"))
						t_rocket[value6]=nil
					else
						v_newx=t_temp[2]+math.cos(t_temp[4])*v_rocket_speed
						v_newy=t_temp[3]+math.sin(t_temp[4])*v_rocket_speed
						imagepos(t_temp[1], v_newx, v_newy, -90+t_temp[4]*180/3.14)
						t_rocket[value6]={t_temp[1],v_newx,v_newy, t_temp[4], t_temp[5]}
					end
				end
			end
		end
	end
end
	
function _objectkill(id,player)
	for v_temp=1,32 do
		for value,key in pairs(t_pre_rocket_turret[v_temp]) do
			t_temp={}
			for value2,key2 in pairs(t_pre_rocket_turret[v_temp][value]) do
				t_temp[value2]=key2
				if value2==4 then
					if object(id, "tilex")==t_temp[2] and object(id, "tiley")==t_temp[3] then
						t_pre_rocket_turret[v_temp][value]=nil
					end
				end
			end
		end
	end
	for v_temp=1,32 do
		if #t_rocket_turret[v_temp]>0 then
		t_temp3={}
		for value5,key5 in pairs(t_rocket_turret[v_temp]) do
			for value6,key6 in pairs(t_rocket_turret[v_temp][value5]) do
			t_temp3[value6]=key6
				if value6==3 then
					if (object(t_temp3[1], "tilex")==object(id, "tilex") and object(t_temp3[1], "tiley")==object(id, "tiley")) then
						if t_temp3[1]==id then
							freeimage(t_temp3[2])
							t_rocket_turret[v_temp][value5]=nil
							parse("explosion "..math.floor(object(id, "x")+16).." "..math.floor(object(id, "y")+16).." 32 0")
						end
					end
				end
			end
		end
		end
	end
end

alreadyx=0
alreadyy=0

function collision(p_self,p2)
	if p2==0 then return true end
	local dist = distance(p_self,p2)
	local dy,dx = player(p2,"y") - object(p_self,"y"),player(p2,"x") - object(p_self,"x")	
	local angle = math.atan2(dy,dx)
	local dy,dx  = math.sin(angle),math.cos(angle)
	for i = 1, dist do
		tx,ty = math.floor((object(p_self,"x")+8+i * dx )/ 32),math.floor((object(p_self,"y")+8+ i*dy)/32)
		if alreadyx~=tx or alreadyy~=ty then
			alreadyx=tx
			alreadyy=ty
			if tile(tonumber(alreadyx),tonumber(alreadyy),"wall")==true then 
				return true
			end
		end
	end	
	return false
end

function fire_rocket(objectid,playerid)
	local dy,dx = player(playerid,"y") - object(objectid,"y")-16,player(playerid,"x") - object(objectid,"x")-16
	local angle = math.atan2(dy,dx)
	table.insert(t_rocket, {image("gfx/weapons/rocket.bmp",math.floor(object(objectid, "x")+16),math.floor(object(objectid, "y")+16), 3), math.floor(object(objectid, "x")+16), math.floor(object(objectid, "y")+16), angle ,objectid})
end

function distance(p1,p2)
	local dx,dy = object(p1, "x") - player(p2,"x"),object(p1,"y")-player(p2,"y")
	return math.floor(math.sqrt(dx*dx + dy*dy))
end

function check_notself(objid,px,py)
	px=math.floor(px/32)
	py=math.floor(py/32)
	if object(objid, "tilex")==px and object(objid, "tiley")==py then return false end
	return true
end

function hit_player(objid,px,py)
	px=math.floor(px/32)
	py=math.floor(py/32)	
	for v_temp=1,32 do
		if player(v_temp, "exists") then
			if player(v_temp, "health")>0 then
				if player(v_temp, "tilex")==px and player(v_temp, "tiley")==py then 
					return true
				end
			end
		end
	end
end

function find_target(objid)
	closest=0
	c_player=0
	for v_temp=1,32 do
		if player(v_temp, "exists") then
			if player(v_temp, "health")>0 then
			if player(v_temp, "team")~=player(object(objid, "player"), "team") then
				if math.abs(player(v_temp, "tilex")-object(objid, "tilex"))<=10 and math.abs(player(v_temp, "tiley")-object(objid, "tiley"))<=10 then
					if closest==0 or distance(objid,v_temp)<closest then
						closest=distance(objid,v_temp)
						c_player=v_temp
					end
				end
			end
			end
		end
	end
	return c_player
end

function distance(turretid,playerid)
	local dx,dy = object(turretid, "x") - player(playerid,"x"),object(turretid,"y")-player(playerid,"y")
	return math.floor(math.sqrt(dx*dx + dy*dy))
end		